#include <bits/stdc++.h>
using namespace std;

int T;
vector<long long> P, K, N;
vector< vector<long long> > A, B, M;
vector<long long> successes;

random_device rd;
mt19937 gen(rd());

int experiment(long long p, long long k, long long n, const vector<long long> &a, const vector<long long> &b, const vector<long long> &m) {
    uniform_int_distribution<> dis(0,p-1);
    long long kprime = dis(gen);
    for (int i=0; i<n; ++i) {
        long long ki = ((a[i] * k + b[i]) % p) % m[i];
        long long kiprime = ((a[i] * kprime + b[i]) % p) % m[i];
        if (ki == kiprime) return 1;
    }
    return 0;
}

int main() {
    cin >> T;
    P.resize(T); K.resize(T); N.resize(T); A.resize(T); B.resize(T); M.resize(T);
    for (int t=0; t<T; ++t) {
        cin >> P[t] >> K[t] >> N[t];
        A[t].resize(N[t]); B[t].resize(N[t]); M[t].resize(N[t]);
        for (int n=0; n<N[t]; ++n) cin >> A[t][n] >> B[t][n] >> M[t][n];
    }
    successes.resize(T,0);
    for (long long loop=0; ; ++loop) {
        for (int t=0; t<T; ++t) {
            successes[t] += experiment( P[t], K[t], N[t], A[t], B[t], M[t] );
        }
        if (loop % 10000 == 0) {
            ofstream fout("e1.mf");
            fout << fixed << setprecision(15);
            for (int t=0; t<T; ++t) fout << (1. * P[t] * successes[t] / loop) << endl;
            fout.close();
        }
    }
}
